-- author: DD ModPassion
-- date: 04.12.2020
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: farming simulator 19
TrailerAddon = {} TrailerAddon.MOD_NAME = g_currentModName function TrailerAddon.prerequisitesPresent(specializations) return true end function TrailerAddon.registerFunctions(vehicleType) SpecializationUtil.registerFunction(vehicleType, "setLimiteRetromarcia", TrailerAddon.setLimiteRetromarcia) end function TrailerAddon.registerEventListeners(vehicleType) SpecializationUtil.registerEventListener(vehicleType, "onLoad", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onReadStream", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdate", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onDraw", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "updateDebugValues", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onPostAttach", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onPreDetach", TrailerAddon) SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", TrailerAddon) end function TrailerAddon:onLoad(savegame) self.spec_trailerAddon = self[string.format("spec_%s.trailerAddon", TrailerAddon.MOD_NAME)] local spec = self.spec_trailerAddon spec.attacherVehicle = nil spec.maxBackwardSpeedBackup = 0 spec.limiteRetromarciaEvent = "" spec.limiteRetromarcia = 4 spec.limiteRetromarciaZero = 0 spec.emptySpeed = 0.25 spec.emptySpeedChange = 6 spec.movingDirectionBackup = 0 end function TrailerAddon:onPostLoad(savegame) local spec = self.spec_trailerAddon self:setLimiteRetromarcia(spec.limiteRetromarcia, spec.emptySpeedChange, true) end function TrailerAddon:saveToXMLFile(xmlFile, key, usedModNames) local spec = self.spec_trailerAddon if spec.attacherVehicle ~= nil then spec.attacherVehicle:getMotor().maxBackwardSpeed = spec.maxBackwardSpeedBackup/3.6 end end function TrailerAddon:onReadStream(streamId, connection) if connection:getIsServer() then local limiteRetromarcia = streamReadInt8(streamId) local emptySpeedChange = streamReadInt8(streamId) self:setLimiteRetromarcia(limiteRetromarcia, emptySpeedChange, true) end end function TrailerAddon:onWriteStream(streamId, connection) if not connection:getIsServer() then local spec = self.spec_trailerAddon streamWriteInt8(streamId, spec.limiteRetromarcia) streamWriteInt8(streamId, spec.emptySpeedChange) end end function TrailerAddon:onUpdate(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_trailerAddon if spec.attacherVehicle ~= nil then local specDischargeable = self.spec_dischargeable if specDischargeable.currentDischargeNode ~= nil then if self.movingDirection < 0 and spec.attacherVehicle.movingDirection < 0 and specDischargeable.currentDischargeState == 0 then spec.attacherVehicle:getMotor().maxBackwardSpeed = spec.limiteRetromarcia/3.6 elseif specDischargeable.currentDischargeState > 0 then spec.attacherVehicle:getMotor().maxBackwardSpeed = 0 if self:getAnimationTime("tipAnimationDoor") < 1 and self.spec_trailer.preferedTipSideIndex == 1 then specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeedChange*(1-self:getAnimationTime("tipAnimationDoor")*0.95) elseif self.spec_trailer.preferedTipSideIndex == 1 then if spec.movingDirectionBackup > 0 and self.movingDirection < 1 then spec.movingDirectionBackup = 0 specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeed+self:getAnimationTime("tipAnimationBack")*spec.emptySpeedChange elseif specDischargeable.currentDischargeNode.emptySpeed > spec.emptySpeed*self:getAnimationTime("tipAnimationBack") then specDischargeable.currentDischargeNode.emptySpeed = specDischargeable.currentDischargeNode.emptySpeed-spec.emptySpeedChange*0.01 else specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeed*self:getAnimationTime("tipAnimationBack") end end if self.lastSpeedReal*1000 > 0.36 and self.movingDirection > 0 then spec.movingDirectionBackup = self.movingDirection end else specDischargeable.currentDischargeNode.emptySpeed = spec.emptySpeed spec.movingDirectionBackup = 0 end elseif self.movingDirection < 0 and spec.attacherVehicle.movingDirection < 0 then spec.attacherVehicle:getMotor().maxBackwardSpeed = spec.limiteRetromarcia/3.6 else spec.attacherVehicle:getMotor().maxBackwardSpeed = spec.maxBackwardSpeedBackup/3.6 end end end function TrailerAddon:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_trailerAddon local specDischargeable = self.spec_dischargeable if spec.attacherVehicle ~= nil and specDischargeable.currentDischargeNode ~= nil then if self.isClient then TrailerAddon.updateActionEvents(self) end local nameFillType = Utils.getNoNil(g_fillTypeManager:getFillTypeNameByIndex(self:getDischargeFillType(specDischargeable.currentDischargeNode)), "unknown") if nameFillType == "CHAFF" or nameFillType == "DRYGRASS" or nameFillType == "GRASS" or nameFillType == "MANURE" or nameFillType == "POTATO" or nameFillType == "SILAGE" or nameFillType == "STRAW" or nameFillType == "SUGARBEET" or nameFillType == "WOODCHIPS" then spec.emptySpeedChange = self:getFillUnitCapacity(1)/1000/4 if self.spec_trailer.preferedTipSideIndex == 1 then spec.emptySpeed = 0.25 else spec.emptySpeed = 0.6 end else spec.emptySpeedChange = self:getFillUnitCapacity(1)/1000/14 if self.spec_trailer.preferedTipSideIndex == 1 then spec.emptySpeed = 1 else spec.emptySpeed = 0.6 end end self:setLimiteRetromarcia(spec.limiteRetromarcia, spec.emptySpeedChange) end end function TrailerAddon:onDraw(isActiveForInput, isActiveForInputIgnoreSelection, isSelected) local spec = self.spec_trailerAddon if spec.limiteRetromarciaEvent ~= nil then local specDischargeable = self.spec_dischargeable if specDischargeable.currentDischargeNode ~= nil then if specDischargeable.currentDischargeState > 0 then g_currentMission:addExtraPrintText(string.format(g_i18n:getText("limiteRetro")..": "..spec.limiteRetromarciaZero.." "..g_i18n:getText("unit_kmh"))) end end end end function TrailerAddon:updateDebugValues(values) local spec = self.spec_trailerAddon local specDischargeable = self.spec_dischargeable if spec.attacherVehicle ~= nil and specDischargeable.currentDischargeNode ~= nil then table.insert(values, {name="emptySpeedChange", value=string.format("%.4f", spec.emptySpeedChange)}) table.insert(values, {name="emptySpeed", value=string.format("%.4f", specDischargeable.currentDischargeNode.emptySpeed)}) table.insert(values, {name="lastSpeedReal", value=string.format("%.4f", self.lastSpeedReal*1000)}) table.insert(values, {name="movingDirectionBackup", value=string.format("%.4f", spec.movingDirectionBackup)}) table.insert(values, {name="movingDirection", value=string.format("%.4f", self.movingDirection)}) table.insert(values, {name="attacherVehicle.movingDirection", value=string.format("%.4f", spec.attacherVehicle.movingDirection)}) table.insert(values, {name="maxBackwardSpeedBackup", value=string.format("%.4f", spec.maxBackwardSpeedBackup)}) table.insert(values, {name="limiteRetromarcia", value=string.format("%.4f", spec.limiteRetromarcia)}) end end function TrailerAddon:onPostAttach(attacherVehicle, inputJointDescIndex, jointDescIndex) local spec = self.spec_trailerAddon spec.attacherVehicle = self:getRootVehicle() if spec.attacherVehicle ~= nil then spec.maxBackwardSpeedBackup = spec.attacherVehicle:getMotor().maxBackwardSpeed*3.6 if spec.maxBackwardSpeedBackup == nil then spec.attacherVehicle = nil end else spec.attacherVehicle = nil end end function TrailerAddon:onPreDetach(attacherVehicle, implement) local spec = self.spec_trailerAddon if spec.attacherVehicle ~= nil then spec.attacherVehicle:getMotor().maxBackwardSpeed = spec.maxBackwardSpeedBackup/3.6 spec.maxBackwardSpeedBackup = 0 spec.attacherVehicle = nil end end function TrailerAddon:onRegisterActionEvents(isActiveForInput, isActiveForInputIgnoreSelection) if self.isClient then local spec = self.spec_trailerAddon spec.limiteRetromarciaEvent = nil self:clearActionEventsTable(spec.actionEvents) if isActiveForInput then local specDischargeable = self.spec_dischargeable if specDischargeable.currentDischargeNode ~= nil then if specDischargeable.currentDischargeState > 0 then g_inputBinding:setActionEventActive(spec.limiteRetromarciaEvent, false) else local _, actionEventId = self:addActionEvent(spec.actionEvents, InputAction.TRAILER_CONTROL, self, TrailerAddon.actionEventCruise, false, true, false, true, nil) g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_HIGH) local text = string.format(g_i18n:getText("action_changeCruiseControlLevel")..": "..spec.limiteRetromarcia.." "..g_i18n:getText("unit_kmh")) spec.limiteRetromarciaEvent = actionEventId g_inputBinding:setActionEventActive(spec.limiteRetromarciaEvent, true) g_inputBinding:setActionEventText(spec.limiteRetromarciaEvent, text) end else local _, actionEventId = self:addActionEvent(spec.actionEvents, InputAction.TRAILER_CONTROL, self, TrailerAddon.actionEventCruise, false, true, false, true, nil) g_inputBinding:setActionEventTextPriority(actionEventId, GS_PRIO_HIGH) local text = string.format(g_i18n:getText("action_changeCruiseControlLevel")..": "..spec.limiteRetromarcia.." "..g_i18n:getText("unit_kmh")) spec.limiteRetromarciaEvent = actionEventId g_inputBinding:setActionEventActive(spec.limiteRetromarciaEvent, true) g_inputBinding:setActionEventText(spec.limiteRetromarciaEvent, text) end end end end function TrailerAddon.actionEventCruise(self, actionName, inputValue, callbackState, isAnalog) local spec = self.spec_trailerAddon local limiteRetromarcia = math.floor(math.max(math.min(spec.maxBackwardSpeedBackup, spec.limiteRetromarcia+inputValue), 1)) local emptySpeedChange = spec.emptySpeedChange self:setLimiteRetromarcia(limiteRetromarcia, emptySpeedChange) end function TrailerAddon:setLimiteRetromarcia(limiteRetromarcia, emptySpeedChange, noEventSend) local spec = self.spec_trailerAddon SetLimiteRetromarciaEvent.sendEvent(self, limiteRetromarcia, emptySpeedChange, noEventSend) spec.limiteRetromarcia = limiteRetromarcia spec.emptySpeedChange = emptySpeedChange end function TrailerAddon.updateActionEvents(self) local spec = self.spec_trailerAddon if spec.limiteRetromarciaEvent ~= nil then local specDischargeable = self.spec_dischargeable if specDischargeable.currentDischargeNode ~= nil then if specDischargeable.currentDischargeState > 0 then g_inputBinding:setActionEventActive(spec.limiteRetromarciaEvent, false) else local text = string.format(g_i18n:getText("action_changeCruiseControlLevel")..": "..spec.limiteRetromarcia.." "..g_i18n:getText("unit_kmh")) g_inputBinding:setActionEventActive(spec.limiteRetromarciaEvent, true) g_inputBinding:setActionEventText(spec.limiteRetromarciaEvent, text) end else local text = string.format(g_i18n:getText("action_changeCruiseControlLevel")..": "..spec.limiteRetromarcia.." "..g_i18n:getText("unit_kmh")) g_inputBinding:setActionEventActive(spec.limiteRetromarciaEvent, true) g_inputBinding:setActionEventText(spec.limiteRetromarciaEvent, text) end end end SetLimiteRetromarciaEvent = {} SetLimiteRetromarciaEvent_mt = Class(SetLimiteRetromarciaEvent, Event) InitEventClass(SetLimiteRetromarciaEvent, "SetLimiteRetromarciaEvent") function SetLimiteRetromarciaEvent:emptyNew() local self = Event:new(SetLimiteRetromarciaEvent_mt) return self end function SetLimiteRetromarciaEvent:new(object, limiteRetromarcia, emptySpeedChange) local self = SetLimiteRetromarciaEvent:emptyNew() self.object = object self.limiteRetromarcia = limiteRetromarcia self.emptySpeedChange = emptySpeedChange return self end function SetLimiteRetromarciaEvent:readStream(streamId, connection) self.object = NetworkUtil.readNodeObject(streamId) self.limiteRetromarcia = streamReadInt8(streamId) self.emptySpeedChange = streamReadInt8(streamId) self:run(connection) end function SetLimiteRetromarciaEvent:writeStream(streamId, connection) NetworkUtil.writeNodeObject(streamId, self.object) streamWriteInt8(streamId, self.limiteRetromarcia) streamWriteInt8(streamId, self.emptySpeedChange) end function SetLimiteRetromarciaEvent:run(connection) if not connection:getIsServer() then g_server:broadcastEvent(self, false, connection, self.object) end if self.object ~= nil then self.object:setLimiteRetromarcia(self.limiteRetromarcia, self.emptySpeedChange, true) end end function SetLimiteRetromarciaEvent.sendEvent(vehicle, limiteRetromarcia, emptySpeedChange, noEventSend) if limiteRetromarcia ~= vehicle.spec_trailerAddon.limiteRetromarcia or emptySpeedChange ~= vehicle.spec_trailerAddon.emptySpeedChange then if noEventSend == nil or noEventSend == false then if g_server ~= nil then g_server:broadcastEvent(SetLimiteRetromarciaEvent:new(vehicle, limiteRetromarcia, emptySpeedChange), nil, nil, vehicle) else g_client:getServerConnection():sendEvent(SetLimiteRetromarciaEvent:new(vehicle, limiteRetromarcia, emptySpeedChange)) end end end end